#ifndef CREATE_CIC_FSC_H
#define CREATE_CIC_FSC_H

#include <iostream>
#include <string>
#include <cstring>
#include <algorithm>
#include <fstream>
#include <openssl/bn.h>
#include <openssl/evp.h>
#include <openssl/provider.h>

using namespace std;

class Create_CIC_FSC
{

#define RSA_E_CIC "862FA7C72F18213D6F963D99DDEC1FBD2E80602780BEF8E84FDE3766B84C7862"
#define MODULO_CIC "FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF5127"

#define RSA_LENGTH 128
#define MD5_DIGEST_LENGTH 16
#define MD5_TWO_LENGTH 0x13
#define MD5_THREE_LENGTH 0x10
#define MD5_LOOP_LENGTH 0x10
#define FINALHASH_LENGTH 13
#define DES_LENGTH 8
#define VIN_LENGTH 7

public:
    Create_CIC_FSC(int argc, char **argv);
    ~Create_CIC_FSC();

private:
    int usage(void);
    bool validateFile(string inFile);
    bool validateHex(string inHex, unsigned char &yearregion);
    int find1BHeader();
    void calc_RSA(void);
    void calc_MD5(unsigned char *des_cblock_key);
    void calc_DES(unsigned char *des_cblock_key, unsigned char *enc_msg);
    void calc_Code(unsigned char *enc_msg);

    typedef struct {
        char header1b[4];               //01 00 1B 00
        char info[21];
        unsigned char vin[7];
        char unused[12];
        unsigned char timestamp[14];
        char headerrsa[3];              //81 0C 80
        unsigned char rsakey01[128];
        char separator;
        unsigned char rsakey02[128];
    } rsa1bstruct;

    char *rsafile;
    unsigned long rsafile_size;
    rsa1bstruct *rsa1bfile;
    const char header1b[4] = {0x01, 0x00, 0x1B, 0x00};

    BIGNUM *encrypted;
    unsigned char regionhigh, regionlow, yearhigh, yearlow;
};

#endif // CREATE_CIC_FSC_H
